web/apps/treso/urls.py
from django.urls import path

from .views import grille_tarifaire, modifier_entree_grille, \
    supprimer_entree_grille, facture_emprunt, emprunts, \
    telecharger_factures, telecharger_devis, telecharger_notes_de_frais, \
    note_de_frais, supprimer_note_de_frais, \
    generer_note_de_frais, generer_devis, supprimer_devis, generer_facture, \
    supprimer_facture, treso, get_facture, get_note_de_frais, \
    facture, devis, liste_client, edit_client, creer_client, \
    supprimer_client, mon_organisation, \
    demande_organisation, generer_organisation_client_particulier, demande_note_de_frais
from .views.note_de_frais import accepter_note_de_frais, refuser_note_de_frais, detail_note_de_frais

urlpatterns = [
    path('facture/emprunt/<int:id_emprunt>/save/', facture_emprunt,
         {'sauvegarder': True},
         name='facture_emprunt_sauvegarder'),
    path('facture/emprunt/<int:id_emprunt>/', facture_emprunt,
         name='facture_emprunt'),
    path('facture/emprunt/', emprunts, name="emprunts_facturables"),

    path('facture/telecharger/<int:facture_id>', get_facture,
         name="telecharger_facture"),
    path('facture/telecharger/', telecharger_factures,
         name='telecharger_factures'),
    path('facture/generer/<int:id_facture>/', generer_facture,
         name='generer_facture'),
    path('facture/supprimer/<int:id_facture>/', supprimer_facture,
         name='supprimer_facture'),
    path('facture/save/', facture, {'sauvegarder': True},
         name='facture_sauvegarder'),
    path('facture/', facture, name='facture'),

    path('devis/telecharger/', telecharger_devis, name='telecharger_devis'),
    path('devis/generer/<int:id_devis>/', generer_devis, name='generer_devis'),
    path('devis/supprimer/<int:id_devis>/', supprimer_devis,
         name='supprimer_devis'),
    path('devis/save/', devis, {'sauvegarder': True},
         name='devis_sauvegarder'),
    path('devis/', devis, name='devis'),

    path('ndf/telecharger/<int:ndf_id>', get_note_de_frais,
         name="telecharger_ndf"),
    path('ndf/telecharger/', telecharger_notes_de_frais,
         name='telecharger_notes_de_frais'),
    path('ndf/generer/<int:id_ndf>/', generer_note_de_frais,
         name='generer_note_de_frais'),
    path('ndf/supprimer/<int:id_ndf>/', supprimer_note_de_frais,
         name='supprimer_note_de_frais'),
    path('ndf/save/', note_de_frais, {'sauvegarder': True},
         name='note_de_frais_sauvegarder'),
    path('ndf/demande/', demande_note_de_frais, name='demande_note_de_frais'),
    path('ndf/<int:id_ndf>/accepter', accepter_note_de_frais, name='accepter_note_de_frais'),
    path('ndf/<int:id_ndf>/refuser', refuser_note_de_frais, name='refuser_note_de_frais'),
    path('ndf/<int:id_ndf>', detail_note_de_frais, name='detail_note_de_frais'),
    path('ndf/', note_de_frais, name='note_de_frais'),


    path('client/liste/', liste_client, name='client'),
    path('client/<int:id_client>/', edit_client, name='edit_client'),
    path('client/', creer_client, name='create_client'),
    path('client/supprimer/<int:id_client>/', supprimer_client,
         name='supprimer_client'),

    path('organisation/', mon_organisation, name='mon_organisation'),
    path('organisation/demande', demande_organisation,
         name='demande_organisation'),
    path('organisation/creation/particulier/<int:id_utilisateur>/',
         generer_organisation_client_particulier,
         name="generer_organisation_client_particulier"),

    path('grille/', grille_tarifaire, name="grille_tarifaire"),
    path('grille/modifier/<int:id_entree>', modifier_entree_grille,
         name="modifier_entree_grille"),
    path('grille/ajouter/', modifier_entree_grille,
         name="ajouter_entree_grille"),
    path('grille/supprimer/<int:id_entree>', supprimer_entree_grille,
         name="supprimer_entree_grille"),

    path('', treso, name="treso")
]

web/intramwet/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('intramwet.core.urls')),
    path('admin/', admin.site.urls),
    path('django-rq/', include('django_rq.urls'))
]

# Sentry testing
if settings.DEBUG:
    def trigger_error(request):
        division_by_zero = 1 / 0

    urlpatterns += path('sentry-debug/', trigger_error),

web/apps/treso/models/note_de_frais.py
from django.db import models
from django.db.models.signals import post_delete
from django.dispatch import receiver
from django.utils.functional import cached_property

from apps.conf.utils import format_file_title
from apps.utilisateur.models import Utilisateur
from .utils import TresoAbstraite


class NoteDeFrais(TresoAbstraite):
    """Note de frais

    Une NoteDeFrais est composée d'ElementNoteDeFrais.
    """
    collaborateur = models.ForeignKey(Utilisateur, on_delete=models.PROTECT,
                                      related_name="notes_de_frais")
    nature = models.CharField("Nature des frais", max_length=200)

    ESP = "ESP"
    CHQ = "CHQ"
    VIR = "VIR"

    justificatif = models.FileField(upload_to='ndf/', null=True, blank=True)

    methode_remboursement = models.CharField(
        "Méthode de remboursement",
        max_length=3,
        choices=[
            (ESP, "En espèces"),
            (CHQ, "Par chèque"),
            (VIR, "Par virement")
        ],
        default=CHQ
    )
    numero_cheque = models.CharField("Numéro du chèque", max_length=200,
                                     null=True, blank=True)
    fichier = models.FileField(upload_to='ndf/', null=True, blank=True)

    class EnumStatut(models.TextChoices):
        ATTENTE = 'ATT', 'En attente'
        VALIDEE = 'VAL', 'Validée'
        REFUSEE = 'REF', 'Refusée'
        REMBOURSEE = 'REM', 'Remboursée'

    statut = models.CharField(
        "Statut de validation",
        max_length=3,
        choices=EnumStatut.choices,
        default=EnumStatut.VALIDEE
    )

    @cached_property
    def nom_fichier(self):
        return format_file_title(
            'N{}_{}_.pdf'.format(self.numero, self.collaborateur.last_name,
                                 self.nature))

    @cached_property
    def nom_justificatif(self):
        return format_file_title(
            'Justificatif{}_{}_.pdf'.format(self.numero, self.collaborateur.last_name,
                                 self.nature))

    @cached_property
    def total(self):
        return sum(e.montant for e in
                   self.elements.all()) if self.elements.all() else 0

    def valider(self):
        if self.statut == self.EnumStatut.ATTENTE:
            self.statut = self.EnumStatut.VALIDEE
            self.save()

    def refuser(self):
        if self.statut == self.EnumStatut.ATTENTE:
            self.statut = self.EnumStatut.REFUSEE
            self.save()

    def __str__(self):
        return "%d | %s | %s" % (self.numero, self.collaborateur, self.nature)


class NoteDeFraisElement(models.Model):
    """Une entrée de note de frais

    Une entrée est caractérisée par le type de frais, ainsi que par son montant
    """
    ndf = models.ForeignKey(NoteDeFrais, on_delete=models.CASCADE,
                            related_name="elements")
    frais = models.CharField("Frais", max_length=200)
    montant = models.FloatField("Montant en €")

    def __str__(self):
        return "%s | %s | %d€" % (self.ndf, self.frais, self.montant)


@receiver(post_delete, sender=NoteDeFrais)
def remove_file_on_delete(sender, instance: NoteDeFrais, **kwargs):
    instance.fichier.delete(False)

web/apps/treso/views/clients.py
from django.contrib.auth import get_user_model
from django.core.exceptions import PermissionDenied
from django.db.models import ProtectedError
from django.http import HttpResponse, JsonResponse
from django.shortcuts import render, redirect, get_object_or_404

from apps.conf.bot import Bot
from ..decorators import can_access_treso, can_manage_treso, \
    can_access_organisation
from ..forms import ClientForm
from ..models import Client


@can_manage_treso
def liste_client(request) -> HttpResponse:
    """ Interface de gestion de tous les clients

    :param request:
    :return:
    """
    clients = Client.objects.all().order_by('nom')
    return render(request, 'treso/clients.html', locals())


@can_manage_treso
def generer_organisation_client_particulier(request,
                                            id_utilisateur: int) -> HttpResponse:
    """ Permet de générer une organisation portant le nom du particulier, en reprenant ses coordonnées

    :param request:
    :param id_utilisateur: id de l'utilisateur
    :return:
    """
    utilisateur = get_user_model().objects.get(id=id_utilisateur)
    utilisateur.organisation, _ = Client.objects.get_or_create(
        nom=utilisateur.nomComplet, adresse=utilisateur.adresse,
        email=utilisateur.email,
        telephone=utilisateur.numeroDeTelephone,
        particulier=True)
    utilisateur.save()
    return redirect('admin_user', id_utilisateur)


@can_access_organisation
def mon_organisation(request) -> HttpResponse:
    """ Permet à un utilisateur de gérer son organisation
    :param request:
    :return:
    """
    organisation = request.user.organisation
    return render(request, 'treso/mon_organisation.html',
                  {'organisation': organisation})


@can_access_treso
def edit_client(request, id_client: int) -> HttpResponse:
    """ Permet au bureau de modifier l'organisation associée à un client, ou au client de modifier sa propre organisation

    :param request:
    :param id_client: l'id du client à modifier
    :return:
    """
    client = get_object_or_404(Client, id=id_client)
    if not request.user.is_staff and request.user.organisation != client:
        raise PermissionDenied
    form = ClientForm(request.POST if request.method == 'POST' else None,
                      instance=client)

    if request.method == 'POST':
        if form.is_valid():
            form.save()
            if request.user.is_staff:
                return redirect('client')
            else:
                return redirect('mon_organisation')

    return render(request, 'treso/edit_client.html', locals())


@can_manage_treso
def creer_client(request) -> HttpResponse:
    """ Permet au bureau de créer l'organisation associée à un client

    :param request:
    :return:
    """
    form = ClientForm(request.POST if request.method == 'POST' else None)

    if request.method == 'POST':
        if form.is_valid():
            form.save()
            return redirect('client')

    return render(request, 'treso/edit_client.html', locals())


@can_manage_treso
def supprimer_client(request, id_client: int) -> HttpResponse:
    """ Permet au bureau de supprimer un client

    :param request:
    :param id_client: id du client à supprimer
    :return:
    """
    try:
        client = get_object_or_404(Client, id=id_client)
        client.delete()
    except ProtectedError:
        pass

    return redirect('client')


@can_access_organisation
def demande_organisation(request) -> HttpResponse:
    """ Informe le bureau qu'un utilisateur souhaite intégrer une organisation lors de l'inscription

    :param request:
    :return:
    """
    if request.method == 'POST':
        Bot('demande_organisation', channel=Bot.CHAN_BUREAU, data={
            'user': request.user,
            'msg': request.POST['organisation']
        }).send()
    return JsonResponse({})

web/apps/treso/views/devis.py
from django.db.models import ProtectedError
from django.http import HttpResponse
from django.shortcuts import render, get_object_or_404, redirect

from apps.conf.utils import get_zipped_response, get_schoolyear
from ..decorators import can_manage_treso
from ..forms import DevisForm, DevisElementFormset
from ..models import Devis, FactureElement, EntreeGrilleTarifaire
from . import traiter_facture, render_pdf_response
from apps.passation.decorators import can_access_passation, register


@can_manage_treso
def devis(request, sauvegarder: bool = False) -> HttpResponse:
    """ Permet de générer un devis

    :param request:
    :param sauvegarder: si on doit sauvegarder le devis, ou juste le générer et renvoyer
    :return:
    """

    template_name = 'treso/devis.html'

    if request.method == 'POST':
        factureform = DevisForm(request.POST)
        formset = DevisElementFormset(request.POST)
        return traiter_facture(factureform=factureform, formset=formset,
                               sauvegarder=sauvegarder, devis=True)

    dernier_numero = Devis.dernier_numero()
    factureform = DevisForm(request.GET or None)
    formset = DevisElementFormset(queryset=FactureElement.objects.none())
    grille_tarifaire = EntreeGrilleTarifaire.objects.all().order_by(
        "categorie", "nom")
    return render(request, template_name, locals())


@can_manage_treso
def generer_devis(request, id_devis: int) -> HttpResponse:
    """ Permet de générer le PDF associé à une facture libre déjà sauvegardée

    :param request:
    :param id_devis: l'id du devis à générer
    :return: le PDF du devis
    """
    facture = get_object_or_404(Devis, id=id_devis)
    devis = True
    return render_pdf_response('treso/rml/facture.rml', facture.nom_fichier,
                               locals())


@can_manage_treso
def supprimer_devis(request, id_devis: int) -> HttpResponse:
    """ Permet de supprimer un devis

    :param request:
    :param id_devis: id du devis à supprimer
    :return:
    """
    try:
        devis = get_object_or_404(Devis, id=id_devis)
        devis.delete()
    except ProtectedError:
        pass
    return redirect('treso')


@can_manage_treso
def telecharger_devis(request) -> HttpResponse:
    files = [f.fichier.path for f in Devis.objects.all() if f.fichier]
    return get_zipped_response(file_list=files,
                               archive_name=f'{get_schoolyear()}_devis.zip')


@register(url='devis/supprimer', name='supprimer_devis_tous',
          verbose_name="Supprimer tous les devis",
          fa_icon="fas fa-trash", btn_class="btn-danger delete")
@can_access_passation
def supprimer_devis_tous(request):
    """ Supprime tous les devis

    :param request:
    :return:
    """
    for devis in Devis.objects.all():
        devis.delete()
    return redirect('passation')

web/apps/treso/views/facture.py
from django.db.models import ProtectedError
from django.http import HttpResponse
from django.shortcuts import render, get_object_or_404, redirect

from apps.conf.utils import get_zipped_response, get_schoolyear, media_response
from ..decorators import can_manage_treso
from ..forms import FactureForm, FactureElementFormset
from ..models import Facture, FactureElement, EntreeGrilleTarifaire
from . import traiter_facture, render_pdf_response
from apps.passation.decorators import can_access_passation, register


@can_manage_treso
def facture(request, sauvegarder: bool = False) -> HttpResponse:
    """ Permet de générer une facture libre.

    Utilise les Formset Django pour relier les éléments à la facture (https://medium.com/@taranjeet/adding-forms-dynamically-to-a-django-formset-375f1090c2b0)
    :param request:
    :param sauvegarder: si on doit sauvegarder la facture, ou juste la générer et renvoyer
    :return:
    """

    template_name = 'treso/facture.html'

    if request.method == 'POST':
        factureform = FactureForm(request.POST)
        formset = FactureElementFormset(request.POST)
        return traiter_facture(factureform=factureform, formset=formset,
                               sauvegarder=sauvegarder)

    dernier_numero = Facture.dernier_numero()
    factureform = FactureForm(request.GET or None)
    formset = FactureElementFormset(queryset=FactureElement.objects.none())
    grille_tarifaire = EntreeGrilleTarifaire.objects.all().order_by(
        "categorie", "nom")
    return render(request, template_name, locals())


@can_manage_treso
def generer_facture(request, id_facture: int) -> HttpResponse:
    """ Permet de générer le PDF associé à une facture libre déjà sauvegardée

    :param request:
    :param id_facture: l'id de la facture libre
    :return: le PDF de la facture
    """
    facture = get_object_or_404(Facture, id=id_facture)
    return render_pdf_response('treso/rml/facture.rml', facture.nom_fichier,
                               locals())


@can_manage_treso
def supprimer_facture(request, id_facture: int) -> HttpResponse:
    """ Permet de supprimer une facture libre de la liste des factures

    :param request:
    :param id_facture: id de la facture à supprimer
    :return:
    """
    try:
        facture = get_object_or_404(Facture, id=id_facture)
        facture.delete()
    except ProtectedError:
        pass
    return redirect('treso')


@can_manage_treso
def get_facture(request, facture_id: int):
    """
    Permet au bureau de récupérer une facture

    :param request:
    :param facture_id: id de l'objet Facture à télécharger
    :return:
    """
    facture = Facture.objects.get(id=facture_id)
    return media_response(facture.fichier.url)


@can_manage_treso
def telecharger_factures(request) -> HttpResponse:
    files = [f.fichier.path for f in Facture.objects.all() if f.fichier]
    return get_zipped_response(file_list=files,
                               archive_name=f'{get_schoolyear()}_factures.zip')


@register(url='factures/supprimer', name='supprimer_factures_toutes',
          verbose_name="Supprimer toutes les factures",
          fa_icon="fas fa-trash", btn_class="btn-danger delete")
@can_access_passation
def supprimer_factures(request):
    """ Supprime toutes les factures

    :param request:
    :return:
    """
    for facture in Facture.objects.all():
        facture.delete()
    return redirect('passation')

web/apps/treso/templates/treso/clients.html
{% extends 'base_navbar.html' %}
{% load static icon %}

{% block title %}
    Clients
{% endblock %}

{% block navbar_tresorerie %}
    active
{% endblock %}

{% block head_css %}
    <link href="{% static 'treso/css/facture.css' %}"
          rel="stylesheet" media="screen">
{% endblock %}

{% block content %}
    <header>
        <h1>Clients</h1>
        <div class="header-content">
            <p>
                Si vous souhaitez supprimer un client, vous devez d'abord supprimer
                toutes les factures qui lui sont associées.
            </p>
        </div>
    </header>

    <div class="container-fluid">
        <h2 class="title">
            Liste des clients
            <button class="btn btn-outline-dark" onclick="location.href='{% url 'create_client' %}'">
                <i class="fas fa-plus-circle"></i> Ajouter un client
            </button>
        </h2>
        {% for client in clients %}
            <div class="card card-lg">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-8">
                            <h3>{{ client }}</h3>
                            {% if client.utilisateurs.all %}
                                Utilisateur{{ client.utilisateurs.all|length|pluralize }} lié
                                {{ client.utilisateurs.all|length|pluralize }} :
                                <ul>
                                    {% for utilisateur in client.utilisateurs.all %}
                                        <li>
                                            <a href="{% url 'admin_user' utilisateur.id %}">{{ utilisateur.nomComplet }}</a>
                                        </li>
                                    {% endfor %}
                                </ul>
                            {% endif %}
                        </div>
                        <div class="col-md-2">
                            <div class="btn-group">
                                <a class="btn btn-dark" href="{% url 'edit_client' client.id %}">Modifier</a>
                                {% if not client.est_lie %}
                                    <a class="btn btn-danger" href="{% url 'supprimer_client' client.id %}"
                                       data-toggle="confirmation" data-btn-ok-label="Supprimer"
                                       data-btn-cancel-label="Annuler" data-btn-ok-class="btn-danger"
                                       data-title="Voulez vous vraiment supprimer le client ?">Supprimer</a>
                                {% endif %}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}


{% block footer_javascript %}
    {# Plugin confirmation box #}
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-confirmation2@4.0.0/dist/bootstrap-confirmation.min.js"></script>

    <script type="text/javascript">
        $(function () {
            $('[data-toggle=confirmation]').confirmation({
                rootSelector: '[data-toggle=confirmation]'
            });
        });
    </script>
{% endblock %}

web/apps/treso/templates/treso/creer_entree_grille.html
{% extends "base_navbar.html" %}
{% load static %}

{% block navbar_projets %}
    active
{% endblock %}

{% block title %}
    Créer une prestation
{% endblock %}

{% block head_css %}
    <link href="{% static 'treso/css/facture.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block header %}
    <header>
        <h1>
            Créer une prestation
        </h1>
        <div class="header-content">
            <p>
                Vous pouvez créer une nouvelle prestation.
                Aucune information ici, n'est, pour l'instant, accessible aux vrais clients.
            </p>
        </div>
    </header>
{% endblock %}

{% block content %}
    <div class="container-fluid">

        <form method="post" action="{% block action %}{% url 'ajouter_entree_grille' %}{% endblock %}">
            {% csrf_token %}

            {% if form.non_field_errors %}
                <div class="alert alert-danger" role="alert">
                    <ul>
                        {% for error in form.non_field_errors %}
                            <li>{{ error }}</li>
                        {% endfor %}
                    </ul>
                </div>
            {% endif %}

            {% for field in form.visible_fields %}
                <div class="form-group row">
                    <div class="col-12">
                        {{ field.label_tag }}

                        {% if field.errors %}
                            <ul>
                                {% for error in field.errors %}
                                    <li>{{ error }}</li>
                                {% endfor %}
                            </ul>
                        {% endif %}

                        {{ field }}
                        {% if field.help_text %}
                            <small class="form-text text-muted">{{ field.help_text }}</small>
                        {% endif %}

                    </div>
                </div>
            {% endfor %}
            <input type="submit" class="btn btn-primary form-control" value="Valider"/>
        </form>
    </div>
{% endblock %}

web/apps/treso/templates/treso/demande_note_de_frais.html
{% extends 'treso/note_de_frais.html' %}
{% load static humanize mathfilters icon %}

{% block demande_ndf %}active{% endblock %}
{% block navbar_tresorerie %}{% endblock %}

{% block header %}
    <header>
        <h1>Demander une note de frais</h1>
        <div class="header-content">
            <p>
                Sur cette page vous pouvez demander une note de frais. Elle devra être validée par le bureau.
            </p>
        </div>
    </header>
{% endblock %}

{% block submissionButtons %}
    <div class="form-group col-md-10">
        <input type="button" name="generer" class="btn btn-outline-dark form-control"
               onclick="send_form('{% url 'demande_note_de_frais' %}')"
               value="Envoyer la demande pour validation" />
    </div>
{% endblock %}

{% block additionalContent %}

    <h2>Mes notes de frais</h2>
    {% for ndf in ndfs %}
        <div class="card card-lg">
            <div class="card-body">
                <div class="row">
                    <div class="col-md-8">
                        <h3 href="#{{ ndf.id }}-details" data-toggle="collapse" aria-expanded="false"
                            class="dropdown-toggle">
                            <span class="badge badge-pill
                                {% if ndf.statut == 'ATT' %}
                                badge-secondary
                                {% elif ndf.statut == 'VAL' %}
                                badge-primary
                                {% elif ndf.statut == 'REF' %}
                                badge-danger
                                {% elif ndf.statut == 'REM' %}
                                badge-success
                                {% endif %}
                                ">
                                {{ ndf.get_statut_display }}
                            </span>
                            N{{ ndf.numero }} ({{ ndf.total|floatformat:2|intcomma }} €)
                        </h3>

                        <p class="collapse" id="{{ ndf.id }}-details">
                            {% for element in ndf.elements.all %}
                                {{ element.frais }} (Montant : {{ element.montant|floatformat:2|intcomma }} €)
                                <br/>
                            {% endfor %}
                        </p>
                    </div>
                </div>
            </div>
        </div>
    {% empty %}
        <p>Vous n'avez pas de note de frais</p>
    {% endfor %}
{% endblock %}

web/apps/treso/templates/treso/detail_note_de_frais.html
{% extends 'treso/note_de_frais.html' %}
{% load static humanize mathfilters icon %}

{% block header %}
    <header>
        <h1>Note de frais N{{ndf.numero}}</h1>
        <div class="header-content">
            <p>
                Sur cette page vous pouvez modifier note de frais.
            </p>
        </div>
    </header>
{% endblock %}

{% block form_target %}{% endblock %}
{% block delete_button %}{% endblock %}
{% block add_button %}{% endblock %}

{% block submissionButtons %}
    <div class="form-group col-md-12">
        <input type="button" name="generer" class="btn btn-outline-dark form-control"
               onclick="send_form('{% url 'detail_note_de_frais' ndf.id %}')"
               value="Modifier la note de frais" />
    </div>
{% endblock %}

web/apps/treso/templates/treso/devis.html
{% extends 'treso/facture.html' %}
{% load static widget_tweaks %}

{% block title %}
    Génération d'un devis
{% endblock %}

{% block header %}
    <header>
        <h1>Générer un devis</h1>
        <div class="header-content">
            <p>
                Sur cette page vous pouvez générer un devis.
            </p>
        </div>
    </header>
{% endblock %}

{% block url_sans_sauvegarde %}'{% url 'devis' %}'{% endblock %}

{% block url_sauvegarde %}'{% url 'devis_sauvegarder' %}'{% endblock %}

web/apps/treso/templates/treso/edit_client.html
{% extends "base_navbar.html" %}
{% load static %}

{% block navbar_tresorerie %}
    active
{% endblock %}

{% block navbar_compte %}
    active
{% endblock %}

{% block title %}
    {% if request.user.is_staff %}
        {% if id_client %}
            Modifier un client
        {% else %}
            Créer un client
        {% endif %}
    {% else %}
        Modifier vos coordonnées
    {% endif %}
{% endblock %}

{% block head_css %}
    <link href="{% static 'treso/css/facture.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block content %}
    <header>
        <h1>
            {% if request.user.is_staff %}
                {% if id_client %}Modifier{% else %}Créer{% endif %} un client
            {% else %}
                Modifier vos coordonnées
            {% endif %}
        </h1>
        <div class="header-content">
            <p>
                {% if request.user.is_staff %}
                    {% if id_client %}
                        Vous souhaitez modifier un client ?
                    {% else %}
                        Vous pouvez créer un nouveau client.
                    {% endif %}
                {% endif %}
                Les informations relatives à l'adresse sont obligatoires car elles servent au système de
                génération de factures.
                {% if request.user.is_staff %}
                    Si vous n'avez pas les informations, contentez-vous d'être un bon
                    trésorier et de laisser les valeurs par défaut.
                {% endif %}
            </p>
        </div>
    </header>

    <div class="container-fluid">

        <form method="post" action="
                {% if id_client %}{% url 'edit_client' id_client %}{% else %}{% url 'create_client' %}{% endif %}">
            {% csrf_token %}

            {% if form.non_field_errors %}
                <div class="alert alert-danger" role="alert">
                    <ul>
                        {% for error in form.non_field_errors %}
                            <li>{{ error }}</li>
                        {% endfor %}
                    </ul>
                </div>
            {% endif %}

            {% for field in form.visible_fields %}
                <div class="form-group row">
                    <div class="col-12">
                        {{ field.label_tag }}

                        {% if field.errors %}
                            <ul>
                                {% for error in field.errors %}
                                    <li>{{ error }}</li>
                                {% endfor %}
                            </ul>
                        {% endif %}

                        {{ field }}
                        {% if field.help_text %}
                            <small class="form-text text-muted">{{ field.help_text }}</small>
                        {% endif %}

                    </div>
                </div>
            {% endfor %}
            <input type="submit" class="btn btn-primary form-control" value="Valider"/>
        </form>
    </div>
{% endblock %}

{% block footer_javascript %}
    <script type="text/javascript">
    </script>
{% endblock %}

web/apps/treso/templates/treso/modifier_entree_grille.html
{% extends "treso/creer_entree_grille.html" %}
{% load static %}

{% block navbar_projets %}
    active
{% endblock %}

{% block title %}
    Modifier une prestation
{% endblock %}

{% block header %}
    <header>
        <h1>
            Modifier une prestation
        </h1>
        <div class="header-content">
            <p>
                Vous souhaitez modifier une prestation ?
                Aucune information ici n'est, pour l'instant, accessible aux vrais clients.
            </p>
        </div>
    </header>
{% endblock %}

{% block action %}{% url 'modifier_entree_grille' id_entree %}{% endblock %}